%define real_name r8168

Summary: Driver for RTL8111/RTL8168 PCI Express Gigabit Ethernet controllers
Name: dkms-r8168
Version: 8.055.00
Release: 1
License: GPL-2.0-only
Group:   System Environment/Kernel
URL:     https://github.com/mtorromeo/r8168
Source:  https://github.com/mtorromeo/r8168/archive/refs/tags/%{version}.tar.gz#/r8168-%{version}.tar.gz
Source1: r8169-blacklist.conf
Source2: dkms-r8168.metainfo.xml
#Patch0:  linux-6.9-compat.patch

BuildArch: noarch
Requires: gcc
Requires: make
Requires: kernel-devel
Requires(post): dkms
Requires(preun): dkms

%description
Driver (Linux kernel module) for RTL8111B/RTL8168B/RTL8111/RTL8168/RTL8111C
PCI Express Gigabit Ethernet controllers.

%prep
%setup -n %{real_name}-%{version}
#%%patch 0 -p1

%build

%install
%{__rm} -rf %{buildroot}

#blacklist r8169 module
%__install -Dm0644 %{SOURCE1} -t %{buildroot}%{_sysconfdir}/modprobe.d

#install appstream metainfo
%__install -Dm0644 %{SOURCE2} -t %{buildroot}%{_metainfodir}

%define dkms_name r8168
%define dkms_vers %{version}-%{release}
%define quiet -q

# Kernel module sources install for dkms
%{__mkdir_p} %{buildroot}%{_usrsrc}/%{dkms_name}-%{dkms_vers}/
%{__cp} -a src/* %{buildroot}%{_usrsrc}/%{dkms_name}-%{dkms_vers}/

# Configuration for dkms
%{__cat} <<'EOF' >%{buildroot}%{_usrsrc}/%{dkms_name}-%{dkms_vers}/dkms.conf
PACKAGE_NAME=%{dkms_name}
PACKAGE_VERSION=%{dkms_vers}
MAKE[0]="'make' -j$(nproc) KVER=${kernelver}"
CLEAN[0]="'make' clean"
BUILT_MODULE_NAME[0]=%{dkms_name}
DEST_MODULE_LOCATION[0]=/kernel/drivers/net
AUTOINSTALL="YES"
EOF

%clean
%{__rm} -rf %{buildroot}

%post
# Add to DKMS registry
dkms add -m %{dkms_name} -v %{dkms_vers} %{?quiet} || :
# Rebuild and make available for the currenty running kernel
dkms build -m %{dkms_name} -v %{dkms_vers} %{?quiet} || :
dkms install -m %{dkms_name} -v %{dkms_vers} %{?quiet} --force || :

%preun
# Remove all versions from DKMS registry
dkms remove -m %{dkms_name} -v %{dkms_vers} %{?quiet} --all || :

%files
%defattr(-, root, root, -)
%doc README
%{_usrsrc}/%{dkms_name}-%{dkms_vers}/
%{_sysconfdir}/modprobe.d/r8169-blacklist.conf
%{_metainfodir}/*.metainfo.xml

%changelog
* Sat Feb 08 2025 Paweł Marciniak <sunwire+repo@gmail.com> - 8.055.00-1
- Version update

* Thu Oct 24 2024 Paweł Marciniak <sunwire+repo@gmail.com> - 8.054.00-1
- Version update

* Tue May 14 2024 Paweł Marciniak <sunwire+repo@gmail.com> - 8.053.00-2
- Add kernel 6.9 patch

* Sun Apr 21 2024 Paweł Marciniak <sunwire+repo@gmail.com> - 8.053.00-1
- Version update

* Sat Mar 16 2024 Paweł Marciniak <sunwire+repo@gmail.com> - 8.052.01-2
- Add strlcpy patch

* Sun Oct 01 2023 Paweł Marciniak <sunwire+repo@gmail.com> - 8.052.01-1
- Version update

* Fri Dec 30 2022 Paweł Marciniak <sunwire+repo@gmail.com> - 8.051.02-6
- Kernel 6.1 patch

* Wed Nov 30 2022 Paweł Marciniak <sunwire+repo@gmail.com> - 8.051.02-1
- Version update

* Sat Oct 29 2022 Paweł Marciniak <sunwire+repo@gmail.com> - 8.050.03-4
- Add patch for kernel 6.1.x

* Thu Oct 13 2022 Paweł Marciniak <sunwire+repo@gmail.com> - 8.050.03-2
- Add patch for kernel 5.19.14

* Mon Oct 10 2022 Paweł Marciniak <sunwire+repo@gmail.com> - 8.050.03-1
- Version update

* Sat Aug 14 2021 Paweł Marciniak <pmarciniak@lodz.home.pl> - 8.049.02-1
- Version update

* Sat Jul 18 2020 Paweł Marciniak <pmarciniak@lodz.home.pl> - 8.048.03-1
- Version update

* Fri Apr 10 2020 Paweł Marciniak <pmarciniak@lodz.home.pl> - 8.048.02-1
- Version update

* Sat Dec 21 2019 Paweł Marciniak <pmarciniak@lodz.home.pl> - 8.047.05-2
- Version update

* Sat Jul 21 2019 Paweł Marciniak <pmarciniak@lodz.home.pl> - 8.047.02-1
- Version update

* Mon Sep 17 2018 Paweł Marciniak <pmarciniak@lodz.home.pl> - 8.046.00-2
- Version update

* Mon Oct 9 2017 Paweł Marciniak <pmarciniak@lodz.home.pl> - 8.045.08-1
- Version update

* Sat Aug 19 2017 Paweł Marciniak <pmarciniak@lodz.home.pl> - 8.042.02-10
- Patch for kernels >= 4.11

* Fri Jun 10 2016 Paweł Marciniak <pmarciniak@lodz.home.pl> - 8.042.00-1
- Version update

* Sun Feb 21 2016 Paweł Marciniak <pmarciniak@lodz.home.pl> - 8.041.01-1
- Version update

* Sun Jan 10 2016 Paweł Marciniak <pmarciniak@lodz.home.pl> - 8.041.00-1
- Version update

* Sat May 23 2015 Paweł Marciniak <pmarciniak@lodz.home.pl> - 8.040.00-1
- Version update

* Fri Sep 19 2014 Paweł Marciniak <pmarciniak@lodz.home.pl> - 8.039.00-1
- Version update

* Tue Oct 8 2013 Paweł Marciniak <pmarciniak@lodz.home.pl> - 8.037.00-1
- Version update

* Fri Aug 2 2013 Paweł Marciniak <pmarciniak@lodz.home.pl> - 8.036.00-2
- Version update

* Thu Jan 3 2013 Paweł Marciniak <pmarciniak@lodz.home.pl> - 8.035.00-1
- Version update

* Sat Dec 15 2012 Paweł Marciniak <pmarciniak@lodz.home.pl> - 8.034.00-5
- Version update, remove unnecessary patches

